#include <stdio.h>
#include <string.h>
#include <windef.h>
#include <winbase.h>
#include <wincon.h>
#include "getpass.h"

char *
getpass( const char *prompt )
{
	HANDLE	stdout_hdl;
	DWORD	cmode;
	size_t	len;
	static	char pwdbuf[ 128 ];

	if ( prompt != NULL ) {
		fputs( prompt, stdout );
		fflush( stdout );
	}

	stdout_hdl = GetStdHandle( STD_OUTPUT_HANDLE );
	if ( GetConsoleMode( stdout_hdl, &cmode )) {
		cmode &= ~ENABLE_ECHO_INPUT;
		SetConsoleMode( stdout_hdl, cmode );
	}

	pwdbuf[0] = '\0';
	(void)fgets( pwdbuf, sizeof(pwdbuf) - 1, stdin );

	cmode |= ENABLE_ECHO_INPUT;
	SetConsoleMode( stdout_hdl, cmode );

	len = strlen( pwdbuf );
	if ( len > 0 && pwdbuf[ len-1 ] == '\n' || pwdbuf[ len-1 ] == '\r' ) {
		pwdbuf[ len-1 ] = '\0';
	}

	return pwdbuf;
}
